
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::SaveSetting(void)
{
    iniSetting->WriteBool("Settings", "cbBackup_Checked", cbBackup->Checked);
    iniSetting->WriteBool("Settings", "cbShowResult_Checked", cbShowResult->Checked);
    iniSetting->WriteBool("Settings", "cbExportData_Checked", cbExportData->Checked);
    iniSetting->WriteBool("Settings", "cbIcon_Checked", cbIcon->Checked);
    iniSetting->WriteBool("Settings", "cbRelocate_Checked", cbRelocate->Checked);
    iniSetting->WriteBool("Settings", "rdoCopy_Checked", rdoCopy->Checked);
    iniSetting->WriteBool("Settings", "rdoSkip_Checked", rdoSkip->Checked);
    iniSetting->WriteBool("Settings", "rdoStrip_Checked", rdoStrip->Checked);
    iniSetting->WriteInteger("Settings", "CSpinEdit1_Value", CSpinEdit1->Value);
    iniSetting->WriteInteger("Settings", "CSpinEdit2_Value", CSpinEdit2->Value);
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::LoadSetting(void)
{
    iniSetting = new TIniFile(ExtractFilePath(Application->ExeName) + "Setting.ini");
    AnsiString szLang = iniSetting->ReadString("Settings", "Language", "English");  // w]^yt
    cbBackup->Checked = iniSetting->ReadBool("Settings", "cbBackup_Checked", false);
    cbShowResult->Checked = iniSetting->ReadBool("Settings", "cbShowResult_Checked", true);
    cbExportData->Checked = iniSetting->ReadBool("Settings", "cbExportData_Checked", true);
    cbIcon->Checked = iniSetting->ReadBool("Settings", "cbIcon_Checked", true);
    cbRelocate->Checked = iniSetting->ReadBool("Settings", "cbRelocate_Checked", true);
    rdoCopy->Checked  = iniSetting->ReadBool("Settings", "rdoCopy_Checked", true);
    rdoSkip->Checked  = iniSetting->ReadBool("Settings", "rdoSkip_Checked", false);
    rdoStrip->Checked = iniSetting->ReadBool("Settings", "rdoStrip_Checked", false);
    CSpinEdit1->Value = iniSetting->ReadInteger("Settings", "CSpinEdit1_Value", 8);
    CSpinEdit2->Value = iniSetting->ReadInteger("Settings", "CSpinEdit2_Value", 2);
    UpdateInterface( szLang );  // {yt
    ListLanguage( szLang );     // ʺAͥiܤyt
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::ListLanguage(AnsiString Language)
{
    AnsiString szFileName;
    char *Name = ".\\Language\\*.ini";
    WIN32_FIND_DATA Data;
    HANDLE hFile = FindFirstFile(Name, &Data);
    bool Res = true;
    if( hFile != INVALID_HANDLE_VALUE )
    {
        while( Res )
        {
            if( !(Data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
            {
                szFileName = AnsiString(Data.cFileName);
                TMenuItem *Item = new TMenuItem( mmLanguage );
                Item->Caption = szFileName.SubString(1, szFileName.Length()-4); // h .ini |Ӧr
                Item->RadioItem = true; // @u@MenuItemiQ
                if( Item->Caption == Language )
                    Item->Checked = true;
                Item->OnClick = smLanguageClick;    // OnClickwBz禡
                mmLanguage->Add(Item);
            }
            Res = FindNextFile(hFile, &Data);
            Application->ProcessMessages();
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::smLanguageClick(TObject *Sender)
{
    TMenuItem *Item = (TMenuItem *)Sender;
    if( Item )
    {
        Item->Checked = true;
        iniSetting->WriteString("Settings", "Language", Item->Caption);
        UpdateInterface( Item->Caption );
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::UpdateInterface(AnsiString Language)
{
    if( FileExists(".\\Language\\" + Language + ".ini" ) )
    {
        iniLang = new TIniFile(ExtractFilePath(Application->ExeName) + "\\Language\\" + Language + ".ini");

        fmMainForm->Caption = iniLang->ReadString("Form", "fmMainForm", "UPX-GUI 媩");
        for( int i = 0; i < fmMainForm->ComponentCount; i++ )    // XҦ Form1 
        {
            if( String(fmMainForm->Components[i]->ClassName()) == "TLabel" )         	// pGO TLabel
              ((TLabel *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TLabel", fmMainForm->Components[i]->Name + "_Caption", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TBitBtn" )      // pGO TBitBtn
              ((TBitBtn *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TBitBtn", fmMainForm->Components[i]->Name + "_Caption", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TButton" )      // pGO TButton
              ((TButton *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TButton", fmMainForm->Components[i]->Name + "_Caption", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TCheckBox" )    // pGO TCheckBox
              ((TCheckBox *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TCheckBox", fmMainForm->Components[i]->Name + "_Caption", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TGroupBox" )    // pGO TGroupBox
              ((TGroupBox *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TGroupBox", fmMainForm->Components[i]->Name + "_Caption", "Win32 / PE");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TMenuItem" )    // pGO TMenuItem
              ((TMenuItem *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TMenuItem", fmMainForm->Components[i]->Name + "_Caption", "-");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TRadioButton" ) // pGO TRadioButton
              ((TRadioButton *)fmMainForm->Components[i])->Caption =
                iniLang->ReadString("TRadioButton", fmMainForm->Components[i]->Name + "_Caption", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TFileListBox" ) // pGO TFileListBox
              ((TFileListBox *)fmMainForm->Components[i])->Hint =
                iniLang->ReadString("TFileListBox", fmMainForm->Components[i]->Name + "_Hint", "");
            else if( String(fmMainForm->Components[i]->ClassName()) == "TListBox" )     // pGO TListBox
              ((TListBox *)fmMainForm->Components[i])->Hint =
                iniLang->ReadString("TListBox", fmMainForm->Components[i]->Name + "_Hint", "");
        }

        delete iniLang;
    }
}
//---------------------------------------------------------------------------
void __fastcall TfmMainForm::SwitchEnabled(bool Enabled)
{
    CSpinEdit1->Enabled = Enabled;
    lblLevel->Enabled = Enabled;
    rdoCopy->Enabled = Enabled;
    rdoSkip->Enabled = Enabled;
    rdoStrip->Enabled = Enabled;
    cbExportData->Enabled = Enabled;
    cbIcon->Enabled = Enabled;
    cbRelocate->Enabled = Enabled;
    CSpinEdit2->Enabled = Enabled;
}
