//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include "cdiroutl.h"
#include <Grids.hpp>
#include <Outline.hpp>
#include <FileCtrl.hpp>
#include <Buttons.hpp>
#include <INIFiles.hpp>
#include "CSPIN.h"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TfmMainForm : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *mmFile;
    TMenuItem *mmLanguage;
    TMenuItem *mmAbout;
    TMenuItem *smExit;
    TDriveComboBox *DriveComboBox1;
    TFilterComboBox *FilterComboBox1;
    TFileListBox *FileListBox1;
    TBitBtn *btnAddAll;
    TBitBtn *btnRemoveAll;
    TListBox *ListBox1;
    TCDirectoryOutline *CDirectoryOutline1;
    TGroupBox *gbCommand;
    TGroupBox *GroupBox2;
    TGroupBox *gbOverlay;
    TGroupBox *gbExtra;
    TButton *btnGo;
    TButton *btnExit;
    TRadioButton *rdoCompress;
    TRadioButton *rdoDecompress;
    TRadioButton *rdoCopy;
    TRadioButton *rdoStrip;
    TRadioButton *rdoSkip;
    TCheckBox *cbBackup;
    TCheckBox *cbExportData;
    TCheckBox *cbIcon;
    TCheckBox *cbRelocate;
    TCheckBox *cbShowResult;
    TCSpinEdit *CSpinEdit1;
    TCSpinEdit *CSpinEdit2;
    TLabel *lblLevel;
    TMenuItem *smSaveSettings;
    TMenuItem *N1;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FilterComboBox1Change(TObject *Sender);
    void __fastcall CDirectoryOutline1Change(TObject *Sender);
    void __fastcall DriveComboBox1Change(TObject *Sender);
    void __fastcall btnExitClick(TObject *Sender);
    void __fastcall smExitClick(TObject *Sender);
    void __fastcall FileListBox1DblClick(TObject *Sender);
    void __fastcall ListBox1DblClick(TObject *Sender);
    void __fastcall btnAddAllClick(TObject *Sender);
    void __fastcall btnRemoveAllClick(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall rdoCompressClick(TObject *Sender);
    void __fastcall rdoDecompressClick(TObject *Sender);
    void __fastcall btnGoClick(TObject *Sender);
    void __fastcall mmAboutClick(TObject *Sender);
    void __fastcall smSaveSettingsClick(TObject *Sender);
private:	// User declarations
    TIniFile *iniLang;
    TIniFile *iniSetting;
    int maxWidth;   // max ListBox1's width
    void __fastcall LoadSetting(void);
    void __fastcall SaveSetting(void);
    void __fastcall ListLanguage(AnsiString Language);
    void __fastcall UpdateInterface(AnsiString Language);
    void __fastcall smLanguageClick(TObject *Sender);
    void __fastcall SwitchEnabled(bool Enabled);
public:		// User declarations
    __fastcall TfmMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMainForm *fmMainForm;
//---------------------------------------------------------------------------
#endif
